<template>
  <div class="file-upload-component">
    <div class="upload">
      <ul class="files-list">
        <li v-for="video in videos"  :key="video.id">
          <span>{{video.name}}</span> -
          <span>{{video.size | prettyBytes}}</span>
          <span v-if="video.error" class="text-danger ml-1" >Произошла Ошибка</span>
          <span v-else-if="video.success"><span class="checked"></span></span>
          <span v-else></span>
        </li>
      </ul>
      <div class="upload-btn">
        <file-upload
          class="button-default"
          :post-action="uploadURL"
          accept="video/mp4"
          v-model="videos"
          @input-filter="inputFilter"
          @input-file="inputFile"
          ref="upload">
          <i class="fa fa-plus"></i>
          Выбрать
        </file-upload>
        <button type="button" class="action-button gray-button" v-show="videos.length >= 1 && !videos[0].success" @click.prevent="$refs.upload.active = true">
          <i class="fa fa-arrow-up" aria-hidden="true"></i>
          Загрузить
        </button>
      </div>
    </div>
    
  </div>
</template>
<style lang="scss">
.file-upload-component {
  .upload-btn {
    display: flex;
    margin-bottom: 0;
  }
  .button-default {
    margin-bottom: 0;
    margin-right: 10px;
    padding-left: 0;
  }
  .files-list {
    list-style-type: none;
    padding: 0;
    font-size: 12px;
    margin-bottom: 10px;
  }

  .action-button {
    margin-top: 0;
    padding: 5px 10px;
    max-width: 100px;
  }

  .checked {
    margin-left: 10px;
    display: inline-block;
  }
}
</style>

<script>
import FileUpload from 'vue-upload-component'
export default {
  components: {
    FileUpload,
  },

  data() {
    return {
      uploadURL: `${process.env.VUE_APP_BASE_URL}/upload-file/videos`,
      videos: []
    }
  },
  methods: {
    inputFilter(newFile, oldFile, prevent) {
      if (newFile && !oldFile) {
        if (/(\/|^)(Thumbs\.db|desktop\.ini|\..+)$/.test(newFile.name)) {
          return prevent()
        }
        if (/\.(php5?|html?|jsx?)$/i.test(newFile.name)) {
          return prevent()
        }
      }
    },
    inputFile(newFile, oldFile) {
      if (newFile && newFile.success) {
        this.$nextTick(() => {
          this.$emit('newVideo', newFile.response);
        });
      }
    }
  }
}
</script>